      SUBROUTINE QSF9R(RINT,A,B,FUN,RO,FI,N,EPS,K,L1,L2,IND,R,IERR)
         INTEGER IND,K,L1,L2,N
         REAL A,B,EPS,FI,R,RINT,RO
         DIMENSION IND(N),R(N,3),RINT(N,2)
         EXTERNAL UTQS10
         INTEGER I,IL,J,J1,J2,J3,J4,K1,KW
         REAL ARG,B1,B2,B3,CRH,CS,DL,EC,ES,H,H2,H4,Q,ROH2,ROH4,SN,SRH,
     1        V,W,WK
         DIMENSION Q(5)
       IL = L1 + L2
       IERR = 0
       DO 10 I = 1, N
          R(I,2) = 0.
          R(I,3) = 0.
          IND(I) = 0
   10  CONTINUE
       K1 = K
       IF (K .LE. 0) K1 = 1
       DL = B - A
       WK = 0.
   20  CONTINUE
       H = DL/K1
       H2 = H/2.
       H4 = H2/2.
       ROH2 = RO*H2
       SRH = SIN(ROH2)
       CRH = COS(ROH2)
       IF (ROH2 .GT. .33) GO TO 30
          ROH4 = RO*H4
          Q(1) = .2666667
          Q(2) = .7111111*COS(ROH4)
          Q(3) = .1555556*CRH
          Q(4) = .7111111*SIN(ROH4)
          Q(5) = .1555556*SRH
          GO TO 40
   30  CONTINUE
       B1 = 1./ROH2
       B2 = B1*B1
       B3 = B2*B2
       Q(1) = 4.*B2*(B1*(48.*B2 - 19.)*SRH + 3.*(1. - 16.*B2)*CRH)
       Q(2) = 32.*B2*(B1*(5. - 12.*B2)*SRH - (1. - 12.*B2)*CRH)/3.
       Q(3) = B1*((3. - 46.*B2 + 96.*B3)*SRH + 2.*B1*(7. - 48.*B2)*
     1        CRH)/3.
       Q(4) = -16.*B2*((1. - 3.*B2)*SRH + 3.*B1*CRH)/3.
       Q(5) = B1*(B1*(11. - 24.*B2)*SRH - 3.*(1. - 8.*B2)*CRH)/3.
   40  CONTINUE
       CALL FUN(A,R,IND)
       DO 80 J = 1, K1
          ARG = A + (2.*J - 1.)*H2
          SN = SIN(ARG*RO+FI)
          CS = COS(ARG*RO+FI)
          DO 50 I = 1, N
             V = Q(3)*R(I,1)
             W = -Q(5)*R(I,1)
             R(I,2) = R(I,2) + SN*V + CS*W
             R(I,3) = R(I,3) + CS*V - SN*W
   50     CONTINUE
          J2 = 2
          J3 = 4
          J4 = -1
          DO 70 J1 = 1, 4
             CALL FUN(ARG + (J1 - 2.)*H4,R,IND)
             DO 60 I = 1, N
                V = Q(J2)*R(I,1)
                W = J4*Q(J3)*R(I,1)
                R(I,2) = R(I,2) + SN*V + CS*W
                R(I,3) = R(I,3) + CS*V - SN*W
   60        CONTINUE
             J2 = J1
             J3 = J1 + 2
             J4 = 1
             IF (J1 .EQ. 1) J4 = 0
   70     CONTINUE
   80  CONTINUE
       KW = 1
       DO 90 I = 1, N
          IF (IND(I) .GT. 0) GO TO 90
             R(I,2) = R(I,2)*H2
             R(I,3) = R(I,3)*H2
             ES = ABS(RINT(I,1) - R(I,2))*L1/(1. + ABS(R(I,3)))
             EC = ABS(RINT(I,IL) - R(I,3))*L2/(1. + ABS(R(I,3)))
             IF (ES .LE. EPS .AND. EC .LE. EPS) IND(I) = K1*WK
             IF (IND(I) .EQ. 0) KW = 0
             RINT(I,1) = R(I,2)
             IF (L2 .NE. 0) RINT(I,IL) = R(I,3)
             R(I,2) = 0.
             R(I,3) = 0.
   90  CONTINUE
       IF (EPS .LE. 0. .OR. KW .GT. 0) GO TO 100
          K1 = K1 + K1
          WK = .5
          IF (K1 .LE. 1048576) GO TO 20
             IERR = 65
             CALL UTQS10(IERR,11)
  100     RETURN
      END
